﻿@Code
    Layout = "~/_AdminLayout.vbhtml"
    'PageData("Title") = "Home Page"
    PageData("Title") = HttpContext.Current.Application("DefaultTitle")

    Dim userDatabase As String = ConfigurationManager.AppSettings("userDatabase")
    Dim datasource As Database = Database.Open(userDatabase)
    Dim sqlQuery As String = "Select Item_ID, Item_Title, Item_Tagline, Item_Featured_Image, Item_Body, Item_Created FROM webpages_Portfolio_Items WHERE Item_Active = 'y' And Item_Featured > 0 Order by Item_Featured Asc"
    Dim rs_portfolio = datasource.Query(sqlQuery)
    Dim numItems As Integer = rs_portfolio.Count()

End Code

@Section featured
    <section class="featured">
        <div class="content-wrapper">
            <hgroup class="title">
                <h1>@PageData("Title").</h1>
                <h2>Modify this template to jump-start your ASP.NET Web Pages application.</h2>
            </hgroup>
            <p>
                To learn more about ASP.NET Web Pages, visit
                <a href="https://asp.net/webpages" title="ASP.NET Web Pages Website">https://asp.net/webpages</a>.
                The page features <mark>videos, tutorials, and samples</mark> to help you get the most from ASP.NET Web Pages.
                If you have any questions about ASP.NET Web Pages, visit
                <a href="https://forums.iis.net/1166.aspx" title="ASP.NET Web Pages Forum">our forums</a>.
            </p>
        </div>
    </section>
End Section
<div class="app_content">
    <div class="row">
        <div class="row-homefeatured">
            <div class="center-wrapper">
                @If Not rs_portfolio.Any() Then
                    @<h2>There Are No Records.</h2>
                Else
                    Dim i As Integer = 1
                    For Each item In rs_portfolio
                        @<text><div Class="col-md-4 equal_height">
                                <div class="@IIf((i Mod 2), "alt_home-featured equal_height", "home-featured equal_height")">
                                    <h2>@i.ToString. @item("Item_Title")</h2>
                                    <h3>@item("Item_Tagline")</h3>
                                    <div class="item-date">@Strings.Left(item("Item_Created"), 12)</div>
                                    <div class="thmb-home-featured">
                                        <img src="~/Portfolio_Images/@item("Item_Featured_Image")" alt="@item("Item_Title")" />
                                    </div>
                                    @StringExtensions.TrimTextProperly(item("Item_Body"), 125, -1, -1, ". . .")
                                </div>
                            </div>
                        </text> i += 1
                    Next
                End If
            </div>
        </div>
    </div>
</div>